#include "robbolito.h"
#include "monitor.h"

void uci()
    {
    char engname[64];
    FILE *f = fopen("Robbo.txt", "r");

    if( f == NULL )
		PRINTF("id name " NAME "\n");
    else
        {
        fgets(engname, 64, f);
        PRINTF("id name %s\n", engname);
        fclose(f);
        }
    PRINTF("id author Yakov Petrovich Golyadkin, Igor Igorovoich Igoronov, Roberto Pescatore\n");
    PRINTF("id copyright Yakov Petrovich Golyadkin (all), 92th year from Revolution, PUBLICDOMAIN (workers)\n");
    PRINTF("id dedication To Vladimir Ilyich\n");
	PRINTF("option name Hash type spin default 64 min 4 max 16384\n");
    PRINTF("uciok\n");
    FFLUSH();
    }
void readyok()
    {
    PRINTF("readyok\n");
    FFLUSH();
    }
static void quit()
    {
    exit(0);
    }
static void parse( char *string )
    {
    char *name, *value;
    int size;

    if( !strcmp(string, "quit") )
        quit();

    if( !strcmp(string, "stop") )
        search_alt(0);

    if( !strcmp(string, "isready") )
        readyok();

    if( !strcmp(string, "ucinewgame") )
        {
        search_alt(0);
        game_new(TRUE);
        }

    if( jump_ok )
        return;

    if( !memcmp(string, "setoption", 9) )
        {
        search_alt(0);
        name = strstr(string, "name ");
        value = strstr(string, "value ");

        if( name == NULL || value == NULL || name >= value )
            return;
        value[-1] = 0;
        name += 5;
        value += 6;

        if( !memcmp(name, "Hash", 4) )
            {
            size = _atoi64(value);

			if( size >= 4 && size <= 16384 )
                {
                size = initialization_zobrist(size);
                }
            }
        }

    if( !memcmp(string, "go", 2) )
        {
        search_initialization(string);

        if( border_legitimate )
            search();
        }

    if( !memcmp(string, "position", 8) )
        positional_initialization(string + 9);

    if( !strcmp(string, "uci") )
        uci();
    }

void input_console()
    {
    char string[65536];
    fgets(string, 65536, stdin);
    string[strlen(string) - 1] = 0;
    parse(string);
    }
